<template>
  <v-app
    v-if="isReady"
    id="inspire"
    :class="{
      'dashboard-background': $route.name === 'Dashboard'
    }"
  >
    <navbar />

    <v-main
      class="fill-height"
      :class="{ [$route.name]: true }"
    >
      <v-container
        style="height: calc(100vh - 64px - 40px);"
        class="mt-5 overflow-auto"
        fluid
      >
        <router-view :key="$route.name" />
      </v-container>
    </v-main>
  </v-app>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState, mapMutations } from 'vuex'

import Navbar from '@/components/Navbar'

import _debounce from 'lodash/debounce'

export default {
  name: 'App',

  components: { Navbar },

  data: () => ({
    drawer: null,
    isReady: 0
  }),

  watch: {
    '$route.meta.auth' (val) {
      if (val) {
        window.addEventListener('click', _debounce(this.handleClickRevalidate, 1000))
      } else {
        window.removeEventListener('click', _debounce(this.handleClickRevalidate, 1000))
      }
    }
  },

  mounted () {
    this.$router.onReady(async () => {
      if (window.localStorage.token) {
        await this.getAuthUser()
      }

      this.isReady = 1
    })
  },

  methods: {
    ...mapActions('users', {
      getAuthUser: 'getAuthUser'
    }),

    ...mapActions('auth', {
      revalidate: 'revalidate'
    }),

    async handleClickRevalidate () {
      try {
        await this.revalidate()
      } catch (error) {
        this.$router.push({ name: 'hero' })
      }
    }
  }
}
</script>

<style lang="scss">

.home {
  .container {
    padding: 0;
  }
}
.dashboard-background {
  background: url('./assets/images/library-dashboard-background.jpg')
    no-repeat center center fixed !important;
  background-size: contain;
}
</style>
